CREATE table "SUBSCRIPTION_CATEGORY" (
    "ID"          NUMBER(12,0) NOT NULL,
    "NAME"        VARCHAR2(255) NOT NULL,
    "DESCRIPTION" VARCHAR2(255),
    constraint  "SUBSCRIPTION_CATEGORY_PK" primary key ("ID")
)
-- SEPARATOR --
CREATE sequence "SUBSCRIPTION_CATEGORY_SEQ" 
-- SEPARATOR --
CREATE trigger "BI_SUBSCRIPTION_CATEGORY" before insert on "SUBSCRIPTION_CATEGORY" for each row begin select "SUBSCRIPTION_CATEGORY_SEQ".nextval into :NEW.ID from dual;end;
-- SEPARATOR --
alter table "SUBSCRIPTION_CATEGORY" add
constraint SUBSCRIPTION_CATEGORY_UK1
unique ("NAME")

-- SEPARATOR --

CREATE table "SUBSCRIPTION_ENCODING" (
    "ID"          NUMBER(12,0) NOT NULL,
    "NAME"        VARCHAR2(255) NOT NULL,
    "DESCRIPTION" VARCHAR2(255),
    constraint  "SUBSCRIPTION_ENCODING_PK" primary key ("ID")
)
-- SEPARATOR --
CREATE sequence "SUBSCRIPTION_ENCODING_SEQ" 
-- SEPARATOR --
CREATE trigger "BI_SUBSCRIPTION_ENCODING" before insert on "SUBSCRIPTION_ENCODING" for each row begin select "SUBSCRIPTION_ENCODING_SEQ".nextval into :NEW.ID from dual;end;
-- SEPARATOR --
alter table "SUBSCRIPTION_ENCODING" add
constraint SUBSCRIPTION_ENCODING_UK1
unique ("NAME")

-- SEPARATOR --

CREATE table "SUBSCRIPTION_MESSAGE" (
    "ID"         NUMBER(12,0) NOT NULL,
    "CATEGORYID" NUMBER(20,0) NOT NULL,
    "SENTDT"     DATE,
    "SUBJECT"    VARCHAR2(255) NOT NULL,
    "SENDER"     VARCHAR2(255) NOT NULL,
    "MESSAGE"    CLOB NOT NULL,
    "STATUSSENT" NUMBER(20,0),
    constraint  "SUBSCRIPTION_MESSAGE_PK" primary key ("ID")
)
-- SEPARATOR --
CREATE sequence "SUBSCRIPTION_MESSAGE_SEQ" 
-- SEPARATOR --
CREATE trigger "BI_SUBSCRIPTION_MESSAGE" before insert on "SUBSCRIPTION_MESSAGE" for each row begin select "SUBSCRIPTION_MESSAGE_SEQ".nextval into :NEW.ID from dual;end;   

-- SEPARATOR --

CREATE table "SUBSCRIPTION_SUBSCRIBER" (
    "ID"				NUMBER(12,0) NOT NULL,
    "EMAIL"				VARCHAR2(255) NOT NULL,
    "SURNAME"			VARCHAR2(255),
    "NAME"				VARCHAR2(255),
    "DESCRIPTION"		VARCHAR2(255),
    "ORGANIZATION"		VARCHAR(255),
    "ADDRESS"			VARCHAR(255),
    "ZIPCODE"			VARCHAR(255),
    "LOCATION"			VARCHAR(255),
    "CONFIRMED"			NUMBER(20,0),
    "CREATEDT"			DATE NOT NULL,
    "ENCODINGID"		NUMBER(20,0),
    "ACTIVE"			NUMBER(20,0) NOT NULL,
    "UNSUBSCRIBE_DATE"	DATE,
    constraint  "SUBSCRIPTION_SUBSCRIBER_PK" primary key ("ID")
)
-- SEPARATOR --
alter table "SUBSCRIPTION_SUBSCRIBER" add
constraint SUBSCRIPTION_SUBSCRBR_UK1
unique ("EMAIL") 
-- SEPARATOR --
CREATE sequence "SUBSCRIPTION_SUBSCRIBER_SEQ" 
-- SEPARATOR --
CREATE trigger "BI_SUBSCRIPTION_SUBSCRIBER" before insert on "SUBSCRIPTION_SUBSCRIBER" for each row begin select "SUBSCRIPTION_SUBSCRIBER_SEQ".nextval into :NEW.ID from dual;end;   

-- SEPARATOR --

CREATE TABLE  "SUBSCRIPTION_SUBSCRIBER_MSG" 
   (	"MESSAGEID" NUMBER(20,0) NOT NULL ENABLE, 
	"SUBSCRIBERID" NUMBER(20,0) NOT NULL ENABLE, 
	"ISOPENED" NUMBER(20,0) NOT NULL ENABLE
   )
-- SEPARATOR --
alter table "SUBSCRIPTION_SUBSCRIBER_MSG" add
constraint SUBSCRIPTION_SUBSCRBR_MSG_UK1
unique ("MESSAGEID","SUBSCRIBERID") 

-- SEPARATOR --

CREATE table "SUBSCRIPTION_SBSCRBR_TO_CAT" (
    "CATEGORYID"   NUMBER(20,0) NOT NULL,
    "SUBSCRIBERID" NUMBER(20,0) NOT NULL
)
-- SEPARATOR --
alter table "SUBSCRIPTION_SBSCRBR_TO_CAT" add
constraint SUBSCR_SBSCRBR_TO_CAT_UK1
unique ("SUBSCRIBERID","CATEGORYID")

-- SEPARATOR --

CREATE OR REPLACE FUNCTION md5_digest(input_string IN VARCHAR2) RETURN VARCHAR2 IS hex_digest varchar2(32);digest varchar2(16);BEGIN digest := DBMS_OBFUSCATION_TOOLKIT.MD5(INPUT_STRING => input_string);SELECT Lower(RAWTOHEX(digest)) INTO hex_digest FROM dual;RETURN hex_digest;END;